"""
BO4E v202401.4.0 - Generated Python implementation of the BO4E standard

BO4E is a standard for the exchange of business objects in the energy industry.
All our software used to generate this BO4E-implementation is open-source and released under the Apache-2.0 license.

The BO4E version can be queried using `bo4e.__version__`.
"""

__all__ = [
    "AbgabeArt",
    "AblesendeRolle",
    "Ablesungsstatus",
    "Adresse",
    "Aggregationsverantwortung",
    "Angebot",
    "Angebotsposition",
    "Angebotsstatus",
    "Angebotsteil",
    "Angebotsvariante",
    "Anrede",
    "ArithmetischeOperation",
    "ArtikelId",
    "AufAbschlag",
    "AufAbschlagProOrt",
    "AufAbschlagRegional",
    "AufAbschlagstaffelProOrt",
    "AufAbschlagstyp",
    "AufAbschlagsziel",
    "Ausschreibung",
    "Ausschreibungsdetail",
    "Ausschreibungslos",
    "Ausschreibungsportal",
    "Ausschreibungsstatus",
    "Ausschreibungstyp",
    "BDEWArtikelnummer",
    "Bankverbindung",
    "Befestigungsart",
    "Bemessungsgroesse",
    "Betrag",
    "Bilanzierung",
    "Bilanzierungsmethode",
    "Buendelvertrag",
    "ConcessionFee",
    "Dienstleistung",
    "Dienstleistungstyp",
    "Dokument",
    "EMobilitaetsart",
    "Energieherkunft",
    "Energiemenge",
    "Energiemix",
    "Energierichtung",
    "Erzeugungsart",
    "File",
    "Fremdkosten",
    "Fremdkostenblock",
    "Fremdkostenposition",
    "Gasqualitaet",
    "Gebiettyp",
    "Geokoordinaten",
    "Geraet",
    "Geraeteklasse",
    "Geraetetyp",
    "Geschaeftspartner",
    "Geschaeftspartnerrolle",
    "Gueltigkeitstyp",
    "Hinweis",
    "HinweisThema",
    "InvoiceStatus",
    "Kalkulationsmethode",
    "Kampagne",
    "Katasteradresse",
    "Konfigurationsprodukt",
    "Kontaktart",
    "Kontaktweg",
    "Konzessionsabgabe",
    "Kosten",
    "Kostenblock",
    "Kostenklasse",
    "Kostenposition",
    "KriteriumWert",
    "Kundengruppe",
    "KundengruppeKA",
    "Kundentyp",
    "Landescode",
    "Lastgang",
    "Lastprofil",
    "Leistungstyp",
    "Lokationstyp",
    "Lokationszuordnung",
    "Marktgebiet",
    "MarktgebietInfo",
    "Marktlokation",
    "Marktrolle",
    "Marktteilnehmer",
    "Medium",
    "Menge",
    "Mengeneinheit",
    "Mengenoperator",
    "Messart",
    "Messgroesse",
    "Messlokation",
    "Messpreistyp",
    "MesstechnischeEinordnung",
    "Messwerterfassung",
    "Messwertstatus",
    "Messwertstatuszusatz",
    "Netzebene",
    "Netzlokation",
    "NetznutzungRechnungsart",
    "NetznutzungRechnungstyp",
    "Oekolabel",
    "Oekozertifikat",
    "Organisationstyp",
    "Person",
    "PositionsAufAbschlag",
    "Preis",
    "Preisblatt",
    "PreisblattDienstleistung",
    "PreisblattHardware",
    "PreisblattKonzessionsabgabe",
    "PreisblattMessung",
    "PreisblattNetznutzung",
    "Preisgarantie",
    "Preisgarantietyp",
    "Preismodell",
    "Preisposition",
    "Preisstaffel",
    "Preisstatus",
    "Preistyp",
    "Profiltyp",
    "Prognosegrundlage",
    "QuantitiesStatus",
    "Rechnung",
    "Rechnungslegung",
    "Rechnungsposition",
    "Rechnungsstatus",
    "Rechnungstyp",
    "Regelzone",
    "Region",
    "RegionaleGueltigkeit",
    "RegionalePreisgarantie",
    "RegionalePreisstaffel",
    "RegionaleTarifpreisposition",
    "RegionalerAufAbschlag",
    "Regionaltarif",
    "Regionskriterium",
    "Regionskriteriumtyp",
    "Registeranzahl",
    "Rollencodetyp",
    "SepaInfo",
    "Sigmoidparameter",
    "Sparte",
    "Speicherart",
    "Standorteigenschaften",
    "StandorteigenschaftenGas",
    "StandorteigenschaftenStrom",
    "SteuerbareRessource",
    "Steuerbetrag",
    "SteuerkanalLeistungsbeschreibung",
    "Steuerkennzeichen",
    "Tarif",
    "Tarifberechnungsparameter",
    "Tarifeinschraenkung",
    "Tarifinfo",
    "Tarifkalkulationsmethode",
    "Tarifkosten",
    "Tarifmerkmal",
    "Tarifpreis",
    "Tarifpreisblatt",
    "Tarifpreisposition",
    "TarifpreispositionProOrt",
    "TarifpreisstaffelProOrt",
    "Tarifregionskriterium",
    "Tariftyp",
    "Tarifzeit",
    "TechnischeRessource",
    "TechnischeRessourceNutzung",
    "TechnischeRessourceVerbrauchsart",
    "Themengebiet",
    "Titel",
    "TransaktionsdatenInvoices",
    "TransaktionsdatenQuantities",
    "Typ",
    "Unterschrift",
    "Variant",
    "Verbrauch",
    "Verbrauchsart",
    "Vertrag",
    "Vertragsart",
    "Vertragsform",
    "Vertragskonditionen",
    "VertragskontoCBA",
    "VertragskontoMBA",
    "Vertragsstatus",
    "Vertragsteil",
    "Verwendungszweck",
    "VerwendungszweckProMarktrolle",
    "Voraussetzungen",
    "Waehrungscode",
    "Waehrungseinheit",
    "Waermenutzung",
    "Wertermittlungsverfahren",
    "Zaehler",
    "ZaehlerGas",
    "Zaehlerauspraegung",
    "Zaehlergroesse",
    "Zaehlertyp",
    "ZaehlertypSpezifikation",
    "Zaehlpunkt",
    "Zaehlwerk",
    "Zaehlzeitregister",
    "Zeitraum",
    "Zeitreihe",
    "Zeitreihenwert",
    "Zeitspanne",
    "ZusatzAttribut",
    "Zustaendigkeit",
    "__version__",
]

from pydantic import BaseModel as _PydanticBaseModel

from .__version__ import __version__
from .bo.angebot import Angebot
from .bo.ausschreibung import Ausschreibung
from .bo.bilanzierung import Bilanzierung
from .bo.buendelvertrag import Buendelvertrag
from .bo.dokument import Dokument
from .bo.energiemenge import Energiemenge
from .bo.file import File
from .bo.fremdkosten import Fremdkosten
from .bo.geraet import Geraet
from .bo.geschaeftspartner import Geschaeftspartner
from .bo.hinweis import Hinweis
from .bo.kampagne import Kampagne
from .bo.kosten import Kosten
from .bo.lastgang import Lastgang
from .bo.lokationszuordnung import Lokationszuordnung
from .bo.marktlokation import Marktlokation
from .bo.marktteilnehmer import Marktteilnehmer
from .bo.messlokation import Messlokation
from .bo.netzlokation import Netzlokation
from .bo.person import Person
from .bo.preisblatt import Preisblatt
from .bo.preisblatt_dienstleistung import PreisblattDienstleistung
from .bo.preisblatt_hardware import PreisblattHardware
from .bo.preisblatt_konzessionsabgabe import PreisblattKonzessionsabgabe
from .bo.preisblatt_messung import PreisblattMessung
from .bo.preisblatt_netznutzung import PreisblattNetznutzung
from .bo.rechnung import Rechnung
from .bo.region import Region
from .bo.regionaltarif import Regionaltarif
from .bo.standorteigenschaften import Standorteigenschaften
from .bo.steuerbare_ressource import SteuerbareRessource
from .bo.tarif import Tarif
from .bo.tarifinfo import Tarifinfo
from .bo.tarifkosten import Tarifkosten
from .bo.tarifpreisblatt import Tarifpreisblatt
from .bo.technische_ressource import TechnischeRessource
from .bo.transaktionsdaten_invoices import TransaktionsdatenInvoices
from .bo.transaktionsdaten_quantities import TransaktionsdatenQuantities
from .bo.vertrag import Vertrag
from .bo.zaehler import Zaehler
from .bo.zaehler_gas import ZaehlerGas
from .bo.zeitreihe import Zeitreihe
from .com.adresse import Adresse
from .com.angebotsposition import Angebotsposition
from .com.angebotsteil import Angebotsteil
from .com.angebotsvariante import Angebotsvariante
from .com.auf_abschlag import AufAbschlag
from .com.auf_abschlag_pro_ort import AufAbschlagProOrt
from .com.auf_abschlag_regional import AufAbschlagRegional
from .com.auf_abschlagstaffel_pro_ort import AufAbschlagstaffelProOrt
from .com.ausschreibungsdetail import Ausschreibungsdetail
from .com.ausschreibungslos import Ausschreibungslos
from .com.bankverbindung import Bankverbindung
from .com.betrag import Betrag
from .com.concession_fee import ConcessionFee
from .com.dienstleistung import Dienstleistung
from .com.energieherkunft import Energieherkunft
from .com.energiemix import Energiemix
from .com.fremdkostenblock import Fremdkostenblock
from .com.fremdkostenposition import Fremdkostenposition
from .com.geokoordinaten import Geokoordinaten
from .com.katasteradresse import Katasteradresse
from .com.konfigurationsprodukt import Konfigurationsprodukt
from .com.kontaktweg import Kontaktweg
from .com.konzessionsabgabe import Konzessionsabgabe
from .com.kostenblock import Kostenblock
from .com.kostenposition import Kostenposition
from .com.kriterium_wert import KriteriumWert
from .com.lastprofil import Lastprofil
from .com.marktgebiet_info import MarktgebietInfo
from .com.menge import Menge
from .com.positions_auf_abschlag import PositionsAufAbschlag
from .com.preis import Preis
from .com.preisgarantie import Preisgarantie
from .com.preisposition import Preisposition
from .com.preisstaffel import Preisstaffel
from .com.rechnungsposition import Rechnungsposition
from .com.regionale_gueltigkeit import RegionaleGueltigkeit
from .com.regionale_preisgarantie import RegionalePreisgarantie
from .com.regionale_preisstaffel import RegionalePreisstaffel
from .com.regionale_tarifpreisposition import RegionaleTarifpreisposition
from .com.regionaler_auf_abschlag import RegionalerAufAbschlag
from .com.regionskriterium import Regionskriterium
from .com.sepa_info import SepaInfo
from .com.sigmoidparameter import Sigmoidparameter
from .com.standorteigenschaften_gas import StandorteigenschaftenGas
from .com.standorteigenschaften_strom import StandorteigenschaftenStrom
from .com.steuerbetrag import Steuerbetrag
from .com.tarifberechnungsparameter import Tarifberechnungsparameter
from .com.tarifeinschraenkung import Tarifeinschraenkung
from .com.tarifpreis import Tarifpreis
from .com.tarifpreisposition import Tarifpreisposition
from .com.tarifpreisposition_pro_ort import TarifpreispositionProOrt
from .com.tarifpreisstaffel_pro_ort import TarifpreisstaffelProOrt
from .com.unterschrift import Unterschrift
from .com.verbrauch import Verbrauch
from .com.vertragskonditionen import Vertragskonditionen
from .com.vertragskonto_cba import VertragskontoCBA
from .com.vertragskonto_mba import VertragskontoMBA
from .com.vertragsteil import Vertragsteil
from .com.verwendungszweck_pro_marktrolle import VerwendungszweckProMarktrolle
from .com.zaehlpunkt import Zaehlpunkt
from .com.zaehlwerk import Zaehlwerk
from .com.zaehlzeitregister import Zaehlzeitregister
from .com.zeitraum import Zeitraum
from .com.zeitreihenwert import Zeitreihenwert
from .com.zeitspanne import Zeitspanne
from .com.zustaendigkeit import Zustaendigkeit
from .enum.abgabe_art import AbgabeArt
from .enum.ablesende_rolle import AblesendeRolle
from .enum.ablesungsstatus import Ablesungsstatus
from .enum.aggregationsverantwortung import Aggregationsverantwortung
from .enum.angebotsstatus import Angebotsstatus
from .enum.anrede import Anrede
from .enum.arithmetische_operation import ArithmetischeOperation
from .enum.artikel_id import ArtikelId
from .enum.auf_abschlagstyp import AufAbschlagstyp
from .enum.auf_abschlagsziel import AufAbschlagsziel
from .enum.ausschreibungsportal import Ausschreibungsportal
from .enum.ausschreibungsstatus import Ausschreibungsstatus
from .enum.ausschreibungstyp import Ausschreibungstyp
from .enum.bdew_artikelnummer import BDEWArtikelnummer
from .enum.befestigungsart import Befestigungsart
from .enum.bemessungsgroesse import Bemessungsgroesse
from .enum.bilanzierungsmethode import Bilanzierungsmethode
from .enum.dienstleistungstyp import Dienstleistungstyp
from .enum.e_mobilitaetsart import EMobilitaetsart
from .enum.energierichtung import Energierichtung
from .enum.erzeugungsart import Erzeugungsart
from .enum.gasqualitaet import Gasqualitaet
from .enum.gebiettyp import Gebiettyp
from .enum.geraeteklasse import Geraeteklasse
from .enum.geraetetyp import Geraetetyp
from .enum.geschaeftspartnerrolle import Geschaeftspartnerrolle
from .enum.gueltigkeitstyp import Gueltigkeitstyp
from .enum.hinweis_thema import HinweisThema
from .enum.invoice_status import InvoiceStatus
from .enum.kalkulationsmethode import Kalkulationsmethode
from .enum.kontaktart import Kontaktart
from .enum.kostenklasse import Kostenklasse
from .enum.kundengruppe import Kundengruppe
from .enum.kundengruppe_ka import KundengruppeKA
from .enum.kundentyp import Kundentyp
from .enum.landescode import Landescode
from .enum.leistungstyp import Leistungstyp
from .enum.lokationstyp import Lokationstyp
from .enum.marktgebiet import Marktgebiet
from .enum.marktrolle import Marktrolle
from .enum.medium import Medium
from .enum.mengeneinheit import Mengeneinheit
from .enum.mengenoperator import Mengenoperator
from .enum.messart import Messart
from .enum.messgroesse import Messgroesse
from .enum.messpreistyp import Messpreistyp
from .enum.messtechnische_einordnung import MesstechnischeEinordnung
from .enum.messwerterfassung import Messwerterfassung
from .enum.messwertstatus import Messwertstatus
from .enum.messwertstatuszusatz import Messwertstatuszusatz
from .enum.netzebene import Netzebene
from .enum.netznutzung_rechnungsart import NetznutzungRechnungsart
from .enum.netznutzung_rechnungstyp import NetznutzungRechnungstyp
from .enum.oekolabel import Oekolabel
from .enum.oekozertifikat import Oekozertifikat
from .enum.organisationstyp import Organisationstyp
from .enum.preisgarantietyp import Preisgarantietyp
from .enum.preismodell import Preismodell
from .enum.preisstatus import Preisstatus
from .enum.preistyp import Preistyp
from .enum.profiltyp import Profiltyp
from .enum.prognosegrundlage import Prognosegrundlage
from .enum.quantities_status import QuantitiesStatus
from .enum.rechnungslegung import Rechnungslegung
from .enum.rechnungsstatus import Rechnungsstatus
from .enum.rechnungstyp import Rechnungstyp
from .enum.regelzone import Regelzone
from .enum.regionskriteriumtyp import Regionskriteriumtyp
from .enum.registeranzahl import Registeranzahl
from .enum.rollencodetyp import Rollencodetyp
from .enum.sparte import Sparte
from .enum.speicherart import Speicherart
from .enum.steuerkanal_leistungsbeschreibung import SteuerkanalLeistungsbeschreibung
from .enum.steuerkennzeichen import Steuerkennzeichen
from .enum.tarifkalkulationsmethode import Tarifkalkulationsmethode
from .enum.tarifmerkmal import Tarifmerkmal
from .enum.tarifregionskriterium import Tarifregionskriterium
from .enum.tariftyp import Tariftyp
from .enum.tarifzeit import Tarifzeit
from .enum.technische_ressource_nutzung import TechnischeRessourceNutzung
from .enum.technische_ressource_verbrauchsart import TechnischeRessourceVerbrauchsart
from .enum.themengebiet import Themengebiet
from .enum.titel import Titel
from .enum.typ import Typ
from .enum.variant import Variant
from .enum.verbrauchsart import Verbrauchsart
from .enum.vertragsart import Vertragsart
from .enum.vertragsform import Vertragsform
from .enum.vertragsstatus import Vertragsstatus
from .enum.verwendungszweck import Verwendungszweck
from .enum.voraussetzungen import Voraussetzungen
from .enum.waehrungscode import Waehrungscode
from .enum.waehrungseinheit import Waehrungseinheit
from .enum.waermenutzung import Waermenutzung
from .enum.wertermittlungsverfahren import Wertermittlungsverfahren
from .enum.zaehlerauspraegung import Zaehlerauspraegung
from .enum.zaehlergroesse import Zaehlergroesse
from .enum.zaehlertyp import Zaehlertyp
from .enum.zaehlertyp_spezifikation import ZaehlertypSpezifikation
from .zusatz_attribut import ZusatzAttribut

# Resolve all ForwardReferences. This design prevents circular import errors.
for cls_name in __all__:
    cls = globals().get(cls_name, None)
    if cls is None or not isinstance(cls, type) or not issubclass(cls, _PydanticBaseModel):
        continue
    cls.model_rebuild(force=True)
